diff -Naur ruby-1.9.3-p547.original/vm.c ruby-1.9.3-p547.htm/vm.c
--- ruby-1.9.3-p547.original/vm.c	2014-01-29 12:42:50.000000000 +0900
+++ ruby-1.9.3-p547.htm/vm.c	2014-09-12 14:02:33.771548000 +0900
@@ -5,6 +5,7 @@
   $Author: usa $
 
   Copyright (C) 2004-2007 Koichi Sasada
+  Copyright (c) IBM Corp. 2014.
 
 **********************************************************************/
 
@@ -1626,8 +1627,27 @@
 	rb_gc_force_recycle(vm->self);
 	vm->main_thread = 0;
 	if (th) {
+#ifdef HTM_GVL
+#ifdef HTM_GVL_SUMMARY_STATS
+	    {
+		extern void accumulate_thr_htm_stats(rb_thread_t *th);
+		accumulate_thr_htm_stats(th);
+	    }
+#endif
+#ifdef HTM_GVL_CYCLE_STATS
+           {
+               extern void accumulate_thr_htm_cycle_stats(rb_thread_t *th);
+               accumulate_thr_htm_cycle_stats(th);
+           }
+#endif
+#endif
 	    rb_fiber_reset_root_local_storage(th->self);
+#if defined(ALIGN_RB_THREAD_T)
+	    thread_free(vm->main_thread_before_aligned);
+	    vm->main_thread_before_aligned = 0;
+#else
 	    thread_free(th);
+#endif
 	}
 	if (vm->living_threads) {
 	    st_free_table(vm->living_threads);
@@ -1640,6 +1660,101 @@
 #endif
 	ruby_vm_run_at_exit_hooks(vm);
 	rb_vm_gvl_destroy(vm);
+#ifdef HTM_GVL
+	if (getenv("RUBY_PRINT_HTM_INSN_STATS") ||
+	    getenv("RH_ISTATS")) {
+	    extern void iseq_print_counter(int64_t *counter, const char *insn_name, rb_iseq_t *iseq, int pos);
+
+	    extern void iseq_get_insn_counters(int64_t *counter_addr, uint32_t *counter0, uint32_t *counter1, uint32_t *counter2);
+	    extern int64_t htm_counter_for_null;
+	    uint32_t counter0, counter1, counter2;
+	    iseq_print_counter(&htm_counter_for_null, "null", NULL, -1);
+	    iseq_get_insn_counters(&htm_counter_for_null, &counter0, &counter1, &counter2);
+	    fprintf(stderr, "#HTM_INSN_STATS ISEQ %p %" PRIu32 " %" PRIu32 " counter_for_null\n",
+		    NULL,
+		    counter1, counter2);
+	}
+	if (getenv("RUBY_PRINT_HTM_STATS") ||
+	    getenv("RH_STATS")) {
+#if defined(__370__)
+	    int i;
+	    const char *reason_string[] = {
+		"TDB_not_set",
+		"Restart_interruption",
+		"External_interruption",
+		NULL,
+		"Program_interruption",
+		"Machine-check_interruption",
+		"I/O_interruption",
+		"Fetch_overflow",
+		"Store_overflow",
+		"Fetch_conflict",
+		"Store_conflict",
+		"Restricted_instruction",
+		"Program-interruption_condition",
+		"Nesting_depth_exceeded",
+		"Cache_fetch-related",
+		"Cache_store-related",
+		"Cache_other",
+		"Undetermined_condition",
+		"TABORT_instruction"
+	    };
+#endif
+
+#ifdef HTM_GVL_SUMMARY_STATS
+	    fprintf(stderr, "#HTM_STATS %15llu           tx_enter\n", vm->htm_stats.tx_enter);
+	    fprintf(stderr, "#HTM_STATS %15llu           tx\n", vm->htm_stats.tx);
+	    fprintf(stderr, "#HTM_STATS %15llu %6.2f %%  gvl_wait_before_tx_spin\n", vm->htm_stats.gvl_wait_before_tx_spin, 100 * vm->htm_stats.gvl_wait_before_tx_spin / (double)vm->htm_stats.tx_enter);
+	    fprintf(stderr, "#HTM_STATS %15llu %6.2f %%  gvl_wait_before_tx_sleep\n", vm->htm_stats.gvl_wait_before_tx_sleep, 100 * vm->htm_stats.gvl_wait_before_tx_sleep / (double)vm->htm_stats.tx_enter);
+	    fprintf(stderr, "#HTM_STATS %15llu %6.2f %%  abort\n", vm->htm_stats.abort, 100 * vm->htm_stats.abort / (double)vm->htm_stats.tx);
+	    fprintf(stderr, "#HTM_STATS %15llu %6.2f %%  first_abort\n", vm->htm_stats.first_abort, 100 * vm->htm_stats.first_abort / (double)vm->htm_stats.tx_enter);
+	    fprintf(stderr, "#HTM_STATS %15llu %6.2f %%  gvl_wait_and_retry_spin\n", vm->htm_stats.gvl_wait_and_retry_spin, 100 * vm->htm_stats.gvl_wait_and_retry_spin / (double)vm->htm_stats.abort);
+	    fprintf(stderr, "#HTM_STATS %15llu %6.2f %%  gvl_wait_and_retry_sleep\n", vm->htm_stats.gvl_wait_and_retry_sleep, 100 * vm->htm_stats.gvl_wait_and_retry_sleep / (double)vm->htm_stats.abort);
+	    fprintf(stderr, "#HTM_STATS %15llu %6.2f %%  gvl_acquired\n", vm->htm_stats.gvl_acquired, 100 * vm->htm_stats.gvl_acquired / (double)vm->htm_stats.abort);
+	    fprintf(stderr, "#HTM_STATS %15llu %6.2f %%  persistent_abort_retry\n", vm->htm_stats.persistent_abort_retry, 100 * vm->htm_stats.persistent_abort_retry / (double)vm->htm_stats.abort);
+	    fprintf(stderr, "#HTM_STATS %15llu %6.2f %%  persistent_abort_gvl_acquired\n", vm->htm_stats.gvl_persistent_abort, 100 * vm->htm_stats.gvl_persistent_abort / (double)vm->htm_stats.abort);
+	    fprintf(stderr, "#HTM_STATS %15llu %6.2f %%  transient_abort_retry\n", vm->htm_stats.transient_abort_retry, 100 * vm->htm_stats.transient_abort_retry / (double)vm->htm_stats.abort);
+	    fprintf(stderr, "#HTM_STATS %15llu %6.2f %%  transient_abort_gvl_acquired\n", vm->htm_stats.gvl_transient_abort, 100 * vm->htm_stats.gvl_transient_abort / (double)vm->htm_stats.abort);
+
+#if defined(__370__)
+	    for (i = 0; i < 19; i++) {
+		if (reason_string[i]) {
+		    unsigned long long total = vm->htm_stats.abort_reason_code[i][0] + vm->htm_stats.abort_reason_code[i][1] + vm->htm_stats.abort_reason_code[i][2];
+		    fprintf(stderr, "#HTM_STATS %15llu %s\n", total, reason_string[i]);
+		}
+	    }
+#elif defined(__x86_64__)
+#define HTM_IA32_STAT(nam) fprintf(stderr, "#HTM_STATS %15llu " #nam "\n", vm->htm_stats.abort_reason_counters.nam );
+#include "htm_ia32_stat.h"
+#undef HTM_IA32_STAT
+#elif defined(__PPC__) || defined(_ARCH_PPC)
+#define HTM_PPC_STAT(nam) fprintf(stderr, "#HTM_STATS %15llu " #nam "\n", vm->htm_stats.abort_reason_counters.nam );
+#include "htm_ppc_stat.h"
+#undef HTM_PPC_STAT
+#else
+#error
+#endif
+#endif /* HTM_GVL_SUMMARY_STATS */
+#ifdef HTM_GVL_CYCLE_STATS
+	    {
+		fprintf(stderr, "#HTM_CYCLE_STATS %20llu msec tx\n", (vm->cycle_stats.tx >> 12) / 1000);
+		fprintf(stderr, "#HTM_CYCLE_STATS %20llu msec abort\n", (vm->cycle_stats.abort >> 12) / 1000);
+#ifdef HTM_GVL_DEFER_GC
+		fprintf(stderr, "#HTM_CYCLE_STATS %20llu msec deferred_gc\n", (vm->cycle_stats.deferred_gc >> 12) / 1000);
+#endif
+		fprintf(stderr, "#HTM_CYCLE_STATS %20llu msec gvl_wait_spin\n", (vm->cycle_stats.gvl_wait_spin >> 12) / 1000);
+		fprintf(stderr, "#HTM_CYCLE_STATS %20llu msec gvl_wait_sleep\n", (vm->cycle_stats.gvl_wait_sleep >> 12) / 1000);
+		fprintf(stderr, "#HTM_CYCLE_STATS %20llu msec gvl\n", (vm->cycle_stats.gvl >> 12) / 1000);
+		fprintf(stderr, "#HTM_CYCLE_STATS %20llu msec between_tx\n", (vm->cycle_stats.between_tx >> 12) / 1000);
+#ifdef HTM_GVL_EAGER_TLH_FILLING
+		fprintf(stderr, "#HTM_CYCLE_STATS %20llu msec eager_gc\n", (vm->cycle_stats.eager_gc >> 12) / 1000);
+#endif
+		fprintf(stderr, "#HTM_CYCLE_STATS %20llu msec mutex_sleep\n", (vm->cycle_stats.mutex_sleep >> 12) / 1000);
+		fprintf(stderr, "#HTM_CYCLE_STATS %20llu msec native_sleep\n", (vm->cycle_stats.native_sleep >> 12) / 1000);
+	    }
+#endif
+	}
+#endif /* HTM_GVL */
 	ruby_xfree(vm);
 	ruby_current_vm = 0;
     }
@@ -1720,12 +1835,32 @@
 #endif
 
 void
+#ifdef ALIGN_RB_THREAD_T
+rb_thread_mark_aligned(void *ptr, int aligned)
+#else
 rb_thread_mark(void *ptr)
+#endif
 {
     rb_thread_t *th = NULL;
     RUBY_MARK_ENTER("thread");
     if (ptr) {
+#if defined(ALIGN_RB_THREAD_T)
+	if (aligned) {
+#if defined(__370__)
+	    th = (rb_thread_t *)(((uintptr_t)ptr + 255) & ~255);
+#elif defined(__x86_64__) || defined(__CYGWIN__)
+	    th = (rb_thread_t *)(((uintptr_t)ptr + 63) & ~63);
+#elif defined(__PPC__) || defined(_ARCH_PPC)
+	    th = (rb_thread_t *)(((uintptr_t)ptr + 127) & ~127);
+#else
+#error
+#endif
+	} else {
+	    th = ptr;
+	}
+#else
 	th = ptr;
+#endif
 	if (th->stack) {
 	    VALUE *p = th->stack;
 	    VALUE *sp = th->cfp->sp;
@@ -1774,6 +1909,24 @@
 	rb_mark_tbl(th->local_storage);
 
 	if (GET_THREAD() != th && th->machine_stack_start && th->machine_stack_end) {
+#ifdef HTM_GVL
+	    if (! th->vm->use_gvl) {
+		while (! th->gc_safe_point_reached)
+		    ;
+	    /* Load-to-load barrier */
+#if defined(__370__)
+	    /* Nothing to do */
+#elif defined(__PPC__) && defined(__IBMC__)
+		__lwsync();
+#elif defined(__PPC__) || defined(_ARCH_PPC)
+		asm volatile("lwsync" : : );
+#elif defined(__GNUC__) || defined(__IBMC__)
+		__sync_synchronize();
+#else
+#error
+#endif
+	    }
+#endif
 	    rb_gc_mark_machine_stack(th);
 	    rb_gc_mark_locations((VALUE *)&th->machine_regs,
 				 (VALUE *)(&th->machine_regs) +
@@ -1786,6 +1939,14 @@
     RUBY_MARK_LEAVE("thread");
 }
 
+#ifdef ALIGN_RB_THREAD_T
+void
+rb_thread_mark(void *ptr)
+{
+    rb_thread_mark_aligned(ptr, 1);
+}
+#endif
+
 static void
 thread_free(void *ptr)
 {
@@ -1793,7 +1954,19 @@
     RUBY_FREE_ENTER("thread");
 
     if (ptr) {
+#if defined(ALIGN_RB_THREAD_T)
+#if defined(__370__)
+	th = (rb_thread_t *)(((uintptr_t)ptr + 255) & ~255);
+#elif defined(__x86_64__) || defined(__CYGWIN__)
+	th = (rb_thread_t *)(((uintptr_t)ptr + 63) & ~63);
+#elif defined(__PPC__) || defined(_ARCH_PPC)
+	th = (rb_thread_t *)(((uintptr_t)ptr + 127) & ~127);
+#else
+#error
+#endif
+#else
 	th = ptr;
+#endif
 
 	if (!th->root_fiber) {
 	    RUBY_FREE_UNLESS_NULL(th->stack);
@@ -1821,8 +1994,10 @@
 #endif
 	    ruby_xfree(ptr);
 	}
+#if RUBY_VM_THREAD_MODEL != 3
         if (ruby_current_thread == th)
             ruby_current_thread = NULL;
+#endif
     }
     RUBY_FREE_LEAVE("thread");
 }
@@ -1832,7 +2007,19 @@
 {
     if (ptr) {
 	const rb_thread_t *th = ptr;
+#if defined(ALIGN_RB_THREAD_T)
+#if defined(__370__)
+	size_t size = sizeof(rb_thread_t) + 256 * 2;
+#elif defined(__x86_64__) || defined(__CYGWIN__)
+	size_t size = sizeof(rb_thread_t) + 64 * 2;
+#elif defined(__PPC__) || defined(_ARCH_PPC)
+	size_t size = sizeof(rb_thread_t) + 128 * 2;
+#else
+#error
+#endif
+#else
 	size_t size = sizeof(rb_thread_t);
+#endif
 
 	if (!th->root_fiber) {
 	    size += th->stack_size * sizeof(VALUE);
@@ -1877,8 +2064,12 @@
     obj = TypedData_Wrap_Struct(klass, &thread_data_type, th);
 #else
     rb_thread_t *th;
+#if defined(ALIGN_RB_THREAD_T)
+    obj = TypedData_Make_Struct_Cache_Line_Aligned(klass, rb_thread_t, &thread_data_type, th);
+#else
     obj = TypedData_Make_Struct(klass, rb_thread_t, &thread_data_type, th);
 #endif
+#endif
     return obj;
 }
 
@@ -1886,6 +2077,9 @@
 th_init(rb_thread_t *th, VALUE self)
 {
     th->self = self;
+#ifdef HTM_GVL
+    th->htm_schedule_counter = 1;
+#endif
 
     /* allocate thread stack */
 #ifdef USE_SIGALTSTACK
@@ -2183,7 +2377,11 @@
 	vm->self = TypedData_Wrap_Struct(rb_cRubyVM, &vm_data_type, vm);
 
 	/* create main thread */
+#if defined(ALIGN_RB_THREAD_T)
+	th_self = th->self = TypedData_Wrap_Struct(rb_cThread, &thread_data_type, vm->main_thread_before_aligned);
+#else
 	th_self = th->self = TypedData_Wrap_Struct(rb_cThread, &thread_data_type, th);
+#endif
 	vm->main_thread = th;
 	vm->running_thread = th;
 	th->vm = vm;
@@ -2220,17 +2418,51 @@
 #if defined(ENABLE_VM_OBJSPACE) && ENABLE_VM_OBJSPACE
 struct rb_objspace *rb_objspace_alloc(void);
 #endif
+#ifdef HTM_GVL
+int rb_htm_schedule_interval;
+uint32_t rb_htm_tx_size_recalc_threshold;
+int rb_htm_persistent_retry_max;
+int rb_htm_transient_retry_max;
+int rb_htm_gvl_retry_max;
+#endif
+#if defined(USE_SIMPLE_GVL_2)
+int rb_gvl_spin_max;
+#endif
 
 void
 Init_BareVM(void)
 {
     /* VM bootstrap: phase 1 */
     rb_vm_t * vm = malloc(sizeof(*vm));
+#if defined(ALIGN_RB_THREAD_T)
+#if defined(__370__)
+    rb_thread_t *th = malloc(sizeof(*th) + 256 * 2);
+#elif defined(__x86_64__) || defined(__CYGWIN__)
+    rb_thread_t *th = malloc(sizeof(*th) + 64 * 2);
+#elif defined(__PPC__) || defined(_ARCH_PPC)
+    rb_thread_t *th = malloc(sizeof(*th) + 128 * 2);
+#else
+#error
+#endif
+    void *th_before_aligned = th;
+#else
     rb_thread_t * th = malloc(sizeof(*th));
+#endif
     if (!vm || !th) {
 	fprintf(stderr, "[FATAL] failed to allocate memory\n");
 	exit(EXIT_FAILURE);
     }
+#if defined(ALIGN_RB_THREAD_T)
+#if defined(__370__)
+    th = (rb_thread_t *)(((uintptr_t)th + 255) & ~255);
+#elif defined(__x86_64__) || defined(__CYGWIN__)
+    th = (rb_thread_t *)(((uintptr_t)th + 63) & ~63);
+#elif defined(__PPC__) || defined(_ARCH_PPC)
+    th = (rb_thread_t *)(((uintptr_t)th + 127) & ~127);
+#else
+#error
+#endif
+#endif
     MEMZERO(th, rb_thread_t, 1);
 
     rb_thread_set_current_raw(th);
@@ -2240,11 +2472,98 @@
     vm->objspace = rb_objspace_alloc();
 #endif
     ruby_current_vm = vm;
+#if defined(ALIGN_RB_THREAD_T)
+    vm->main_thread_before_aligned = th_before_aligned;
+#endif
 
     Init_native_thread();
     th_init(th, 0);
     th->vm = vm;
     ruby_thread_init_stack(th);
+#ifdef HTM_GVL
+    {
+	char *sched_interval;
+	char *tx_size_recalc_threshold;
+	char *persistent_retry_max;
+	char *transient_retry_max;
+	char *gvl_retry_max;
+	double recalc_threshold_percent;
+
+	sched_interval = getenv("RUBY_HTM_SCHED_INTERVAL");
+	if (! sched_interval)
+	    sched_interval = getenv("RH_INTV");
+	if (sched_interval) {
+	    rb_htm_schedule_interval = atoi(sched_interval);
+	    if (rb_htm_schedule_interval == 0)
+		rb_htm_schedule_interval = 1;
+	    else if (rb_htm_schedule_interval <= -256)
+		rb_htm_schedule_interval = -255;
+	    fprintf(stderr, "<RUBY_VM: RUBY_HTM_SCHED_INTERVAL set to %d>\n", rb_htm_schedule_interval);
+	} else {
+	    rb_htm_schedule_interval = -255;
+	}
+
+	tx_size_recalc_threshold = getenv("RUBY_HTM_TX_SIZE_RECALC_THRESHOLD");
+	if (! tx_size_recalc_threshold)
+	    tx_size_recalc_threshold = getenv("RH_RECALC");
+	if (tx_size_recalc_threshold) {
+	    recalc_threshold_percent = atof(tx_size_recalc_threshold);
+	    if (recalc_threshold_percent < 0.0 || 100.0 < recalc_threshold_percent) {
+		recalc_threshold_percent = 6.0;
+	    }
+	    fprintf(stderr, "<RUBY_VM: RUBY_HTM_TX_SIZE_RECALC_THRESHOLD set to %f>\n", recalc_threshold_percent);
+	} else {
+	    recalc_threshold_percent = 6.0;
+	}
+	rb_htm_tx_size_recalc_threshold = (int)(recalc_threshold_percent * HTM_WAIT_AND_SEE_PERIOD / 100);
+	if (rb_htm_tx_size_recalc_threshold <= 0)
+	    rb_htm_tx_size_recalc_threshold = 1;
+
+	persistent_retry_max = getenv("RUBY_HTM_PERSISTENT_RETRY_MAX");
+	if (! persistent_retry_max)
+	    persistent_retry_max = getenv("RH_PRETRY");
+	if (persistent_retry_max) {
+	    rb_htm_persistent_retry_max = atoi(persistent_retry_max);
+	    fprintf(stderr, "<RUBY_VM: RUBY_HTM_PERSISTENT_RETRY_MAX set to %d>\n", rb_htm_persistent_retry_max);
+	} else {
+	    rb_htm_persistent_retry_max = 3;
+	}
+
+	transient_retry_max = getenv("RUBY_HTM_TRANSIENT_RETRY_MAX");
+	if (! transient_retry_max)
+	    transient_retry_max = getenv("RH_TRETRY");
+	if (transient_retry_max) {
+	    rb_htm_transient_retry_max = atoi(transient_retry_max);
+	    fprintf(stderr, "<RUBY_VM: RUBY_HTM_TRANSIENT_RETRY_MAX set to %d>\n", rb_htm_transient_retry_max);
+	} else {
+	    rb_htm_transient_retry_max = 3;
+	}
+
+	gvl_retry_max = getenv("RUBY_HTM_GVL_RETRY_MAX");
+	if (! gvl_retry_max)
+	    gvl_retry_max = getenv("RH_GRETRY");
+	if (gvl_retry_max) {
+	    rb_htm_gvl_retry_max = atoi(gvl_retry_max);
+	    fprintf(stderr, "<RUBY_VM: RUBY_HTM_GVL_RETRY_MAX set to %d>\n", rb_htm_gvl_retry_max);
+	} else {
+	    rb_htm_gvl_retry_max = 16;
+	}
+    }
+#endif /* HTM_GVL */
+#if defined(USE_SIMPLE_GVL_2)
+    {
+	char *gvl_spin_max;
+	gvl_spin_max = getenv("RUBY_GVL_SPIN_MAX");
+	if (! gvl_spin_max)
+	    gvl_spin_max = getenv("RB_GSPIN");
+	if (gvl_spin_max) {
+	    rb_gvl_spin_max = atoi(gvl_spin_max);
+	    fprintf(stderr, "<RUBY_VM: RUBY_GVL_SPIN_MAX set to %d>\n", rb_gvl_spin_max);
+	} else {
+	    rb_gvl_spin_max = 100000000;
+	}
+    }
+#endif
 }
 
 /* top self */
@@ -2285,6 +2604,14 @@
     return &vm->debug;
 }
 
+#if RUBY_VM_THREAD_MODEL == 3
+int *
+ruby_vm_use_gvl_ptr(rb_vm_t *vm)
+{
+    return &vm->use_gvl;
+}
+#endif
+
 VALUE *
 rb_ruby_verbose_ptr(void)
 {
@@ -2296,3 +2623,14 @@
 {
     return ruby_vm_debug_ptr(GET_VM());
 }
+
+int *
+rb_ruby_use_gvl_ptr(void)
+{
+#if RUBY_VM_THREAD_MODEL == 3
+    return ruby_vm_use_gvl_ptr(GET_VM());
+#else
+    assert(0);
+    return NULL;
+#endif
+}
diff -Naur ruby-1.9.3-p547.original/vm_core.h ruby-1.9.3-p547.htm/vm_core.h
--- ruby-1.9.3-p547.original/vm_core.h	2013-01-11 17:13:17.000000000 +0900
+++ ruby-1.9.3-p547.htm/vm_core.h	2014-09-12 06:37:35.905002000 +0900
@@ -6,13 +6,20 @@
   created at: 04/01/01 19:41:38 JST
 
   Copyright (C) 2004-2007 Koichi Sasada
+  Copyright (c) IBM Corp. 2014.
 
 **********************************************************************/
 
 #ifndef RUBY_VM_CORE_H
 #define RUBY_VM_CORE_H
 
+#ifdef HTM_GVL
+#if ! defined(RUBY_VM_THREAD_MODEL)
+#define RUBY_VM_THREAD_MODEL 3
+#endif
+#else
 #define RUBY_VM_THREAD_MODEL 2
+#endif
 
 #include "ruby/ruby.h"
 #include "ruby/st.h"
@@ -23,6 +30,33 @@
 #include "id.h"
 #include "method.h"
 #include "ruby_atomic.h"
+#ifdef HTM_GVL
+#include "htm_util.h"
+#endif
+
+#ifdef HTM_GVL
+#define HTM_WAIT_AND_SEE_PERIOD 300
+
+#define HTM_GVL_SUMMARY_STATS
+
+/*#define HTM_GVL_CYCLE_STATS*/
+
+#define USE_SIMPLE_GVL_2
+
+/* Enabled only for HTM */
+#define USE_TABLE_FOR_IC_IVAR
+#define ADAPTIVE_INLINE_METHOD_CACHE  /* This is not adaptive in fact, for now. */
+#define ADAPTIVE_GLOBAL_METHOD_CACHE  /* This is not adaptive in fact, for now. */
+
+#define USE_THREAD_LOCAL_HEAP
+
+#define ALIGN_RB_THREAD_T
+
+#endif /* HTM_GVL */
+
+#if defined(USE_SIMPLE_GVL_2)
+extern int rb_gvl_spin_max;
+#endif
 
 #if   defined(_WIN32)
 #include "thread_win32.h"
@@ -127,7 +161,14 @@
 
 struct iseq_inline_cache_entry {
     VALUE ic_vmstat;
+#ifdef USE_TABLE_FOR_IC_IVAR
+    union {
+	struct st_table *ic_tbl;
+	VALUE ic_class;
+    } ic_guard;
+#else
     VALUE ic_class;
+#endif
     union {
 	VALUE value;
 	rb_method_entry_t *method;
@@ -170,6 +211,9 @@
     VALUE filepath;      /* real file path or nil */
     VALUE *iseq;         /* iseq (insn number and operands) */
     VALUE *iseq_encoded; /* encoded iseq */
+#ifdef HTM_GVL
+    int64_t *htm_counters;
+#endif
     unsigned long iseq_size;
     VALUE mark_ary;	/* Array: includes operands which should be GC marked */
     VALUE coverage;     /* coverage array */
@@ -274,12 +318,69 @@
 void rb_objspace_free(struct rb_objspace *);
 #endif
 
+#ifdef HTM_GVL
+typedef struct rb_htm_stats_struct {
+    unsigned long long tx;
+    unsigned long long tx_enter;
+    unsigned long long abort;
+    unsigned long long first_abort;
+    unsigned long long gvl_wait_before_tx_spin;
+    unsigned long long gvl_wait_before_tx_sleep;
+    unsigned long long gvl_wait_and_retry_spin;
+    unsigned long long gvl_wait_and_retry_sleep;
+    unsigned long long gvl_acquired;
+    unsigned long long persistent_abort_retry;
+    unsigned long long gvl_persistent_abort;
+    unsigned long long transient_abort_retry;
+    unsigned long long gvl_transient_abort;
+#if defined(__370__)
+    unsigned long long abort_reason_code[19][3];
+#elif defined(__x86_64__)
+#define HTM_IA32_STAT(nam) unsigned long long nam;
+    struct {
+#include "htm_ia32_stat.h"
+    } abort_reason_counters;
+#undef HTM_IA32_STAT
+#elif defined(__PPC__) || defined(_ARCH_PPC)
+#define HTM_PPC_STAT(NAM) unsigned long long NAM;
+    struct {
+#include "htm_ppc_stat.h"
+    } abort_reason_counters;
+#undef HTM_PPC_STAT
+#else
+#error
+#endif
+} rb_htm_stats_t;
+
+typedef struct rb_htm_cycle_stats_struct {
+    unsigned long long tx;
+    unsigned long long abort;
+    unsigned long long gvl_wait_spin;
+    unsigned long long gvl_wait_sleep;
+    unsigned long long gvl;
+    unsigned long long between_tx;
+    unsigned long long mutex_sleep;
+    unsigned long long native_sleep;
+} rb_htm_cycle_stats_t;
+
+extern int rb_htm_schedule_interval;
+extern uint64_t rb_htm_count_reason_code;
+extern int use_non_tx_store;
+extern uint32_t rb_htm_tx_size_recalc_threshold;
+extern int rb_htm_persistent_retry_max;
+extern int rb_htm_transient_retry_max;
+extern int rb_htm_gvl_retry_max;
+#endif /* HTM_GVL */
+
 typedef struct rb_vm_struct {
     VALUE self;
 
     rb_global_vm_lock_t gvl;
 
     struct rb_thread_struct *main_thread;
+#if defined(ALIGN_RB_THREAD_T)
+    void *main_thread_before_aligned;
+#endif
     struct rb_thread_struct *running_thread;
 
     st_table *living_threads;
@@ -327,6 +428,15 @@
      * objects so do *NOT* mark this when you GC.
      */
     struct RArray at_exit;
+#if RUBY_VM_THREAD_MODEL == 3
+    int use_gvl;
+#endif
+#if defined(HTM_GVL) && defined(HTM_GVL_SUMMARY_STATS)
+    rb_htm_stats_t htm_stats;
+#endif
+#if defined(HTM_GVL) && defined(HTM_GVL_CYCLE_STATS)
+    rb_htm_cycle_stats_t cycle_stats;
+#endif
 } rb_vm_t;
 
 typedef struct {
@@ -353,8 +463,29 @@
 
 extern const rb_data_type_t ruby_threadptr_data_type;
 
+#if defined(ALIGN_RB_THREAD_T)
+#if defined(__370__)
+#define GetThreadPtr(obj, ptr) do {					\
+	TypedData_Get_Struct((obj), rb_thread_t, &ruby_threadptr_data_type, (ptr)); \
+	(ptr) = (rb_thread_t *)(((uintptr_t)(ptr) + 255) & ~255);	\
+    } while (0)
+#elif defined(__x86_64__) || defined(__CYGWIN__)
+#define GetThreadPtr(obj, ptr) do {					\
+	TypedData_Get_Struct((obj), rb_thread_t, &ruby_threadptr_data_type, (ptr)); \
+	(ptr) = (rb_thread_t *)(((uintptr_t)(ptr) + 63) & ~63);	\
+    } while (0)
+#elif defined(__PPC__) || defined(_ARCH_PPC)
+#define GetThreadPtr(obj, ptr) do {					\
+	TypedData_Get_Struct((obj), rb_thread_t, &ruby_threadptr_data_type, (ptr)); \
+	(ptr) = (rb_thread_t *)(((uintptr_t)(ptr) + 127) & ~127);	\
+    } while (0)
+#else
+#error
+#endif
+#else
 #define GetThreadPtr(obj, ptr) \
     TypedData_Get_Struct((obj), rb_thread_t, &ruby_threadptr_data_type, (ptr))
+#endif
 
 enum rb_thread_status {
     THREAD_TO_KILL,
@@ -393,6 +524,12 @@
 typedef struct rb_thread_struct {
     VALUE self;
     rb_vm_t *vm;
+#ifdef HTM_GVL
+    int htm_schedule_counter;
+#endif
+#ifdef USE_THREAD_LOCAL_HEAP
+    void *tlh_free_list;
+#endif
 
     /* execution information */
     VALUE *stack;		/* must free, must mark */
@@ -491,6 +628,20 @@
     void *altstack;
 #endif
     unsigned long running_time_us;
+#ifdef HTM_GVL
+    volatile int gc_safe_point_reached;
+    TransactionDiagnosticInfo diag;
+#ifdef HTM_GVL_SUMMARY_STATS
+    rb_htm_stats_t htm_stats;
+#endif
+#ifdef HTM_GVL_CYCLE_STATS
+    const char *saved_file;
+    int saved_line;
+    uint64_t saved_cycle;
+    unsigned long long *cycle_charging_target;
+    rb_htm_cycle_stats_t cycle_stats;
+#endif
+#endif
 } rb_thread_t;
 
 /* iseq.c */
@@ -697,6 +848,24 @@
     (th)->vm->running_thread = (th); \
 } while (0)
 
+#elif RUBY_VM_THREAD_MODEL == 3
+RUBY_EXTERN rb_thread_t *ruby_current_thread;
+extern rb_vm_t *ruby_current_vm;
+extern rb_thread_t *ruby_thread_from_native(void);
+
+#define GET_VM() ruby_current_vm
+#define GET_THREAD() ruby_thread_from_native()
+#define rb_thread_set_current_raw(th) (void)(ruby_current_thread = (th))
+#define rb_thread_set_current(th) do {				\
+    if ((th)->vm->use_gvl) {					\
+	if ((th)->vm->running_thread != (th)) {			\
+	    (th)->vm->running_thread->running_time_us = 0;	\
+	}							\
+	rb_thread_set_current_raw(th);				\
+	(th)->vm->running_thread = (th);			\
+    }								\
+} while (0)
+
 #else
 #error "unsupported thread model"
 #endif
@@ -718,6 +887,103 @@
 void rb_thread_lock_unlock(rb_thread_lock_t *);
 void rb_thread_lock_destroy(rb_thread_lock_t *);
 
+#if defined(HTM_GVL) && defined(HTM_GVL_CYCLE_STATS)
+#if 0
+#define HTM_GVL_DEBUG_CYCLES_1(trgt)						\
+	if (cycle - th->saved_cycle > 0x1000 * 1000)			\
+	    fprintf(stderr, "charge %llu " #trgt " %s %d\n", (cycle - th->saved_cycle) >> 12, __FILE__, __LINE__);
+#else
+#define HTM_GVL_DEBUG_CYCLES_1(trgt)
+#endif
+#if 0
+#define HTM_GVL_DEBUG_CYCLES_2()       \
+    th->saved_file = __FILE__; \
+    th->saved_line = __LINE__;
+#else
+#define HTM_GVL_DEBUG_CYCLES_2()
+#endif
+
+#define HTM_GVL_START_CYCLES()						\
+    do {								\
+	uint64_t cycle;							\
+	store_clock(&cycle);						\
+	th->saved_cycle = cycle;					\
+	th->cycle_charging_target = NULL;				\
+	HTM_GVL_DEBUG_CYCLES_2();					\
+    } while (0)
+#define HTM_GVL_CHARGE_CYCLES_TO_SAVED_TARGET()				\
+    do {								\
+	uint64_t cycle;							\
+	store_clock(&cycle);						\
+	if (th->cycle_charging_target != NULL)				\
+	    *th->cycle_charging_target += cycle - th->saved_cycle;	\
+	HTM_GVL_DEBUG_CYCLES_1(saved);					\
+	th->saved_cycle = cycle;					\
+	th->cycle_charging_target = NULL;				\
+	HTM_GVL_DEBUG_CYCLES_2();					\
+    } while (0)
+#define HTM_GVL_CHARGE_CYCLES_TO(trgt)					\
+    do {								\
+	uint64_t cycle;							\
+	store_clock(&cycle);						\
+	if (th->saved_cycle != 0)					\
+	    th->cycle_stats.trgt += cycle - th->saved_cycle;		\
+	HTM_GVL_DEBUG_CYCLES_1(trgt);					\
+	th->saved_cycle = cycle;					\
+	th->cycle_charging_target = NULL;				\
+	HTM_GVL_DEBUG_CYCLES_2();					\
+    } while (0)
+#define HTM_GVL_CHARGE_CYCLES_TO_AND_START(trgt1, trgt2)		\
+    do {								\
+	uint64_t cycle;							\
+	store_clock(&cycle);						\
+	if (th->saved_cycle != 0)					\
+	    th->cycle_stats.trgt1 += cycle - th->saved_cycle;		\
+	HTM_GVL_DEBUG_CYCLES_1(trgt1);					\
+	th->saved_cycle = cycle;					\
+	th->cycle_charging_target = &th->cycle_stats.trgt2;		\
+	HTM_GVL_DEBUG_CYCLES_2();					\
+    } while (0)
+#define HTM_GVL_CHANGE_CYCLE_CHARGING_TO(trgt)				\
+    do {								\
+	th->cycle_charging_target = &th->cycle_stats.trgt;		\
+    } while (0)
+#else /* HTM_GVL && HTM_GVL_CYCLE_STATS */
+#define HTM_GVL_START_CYCLES()
+#define HTM_GVL_CHARGE_CYCLES_TO_SAVED_TARGET()
+#define HTM_GVL_CHARGE_CYCLES_TO(trgt)
+#define HTM_GVL_CHARGE_CYCLES_TO_AND_START(trgt1, trgt2)
+#define HTM_GVL_CHANGE_CYCLE_CHARGING_TO(trgt)
+#endif /* HTM_GVL && HTM_GVL_CYCLE_STATS */
+
+#ifdef HTM_GVL
+#define RUBY_VM_CHECK_INTS_EXEC_CORE(cntaddr) do {		\
+    if (UNLIKELY((self_th)->interrupt_flag)) {			\
+	rb_threadptr_execute_interrupts(self_th);		\
+    }								\
+    if (! use_gvl) {						\
+	thread_alone = rb_thread_alone_fast(self_th);		\
+	RUBY_VM_HTM_CHECK_SCHED(cntaddr);			\
+    }								\
+} while (0)
+
+#define RUBY_VM_HTM_CHECK_SCHED(cntaddr) do {				\
+    if (! use_gvl && ! thread_alone) {					\
+	local_schedule_counter = --self_th->htm_schedule_counter;	\
+	if (local_schedule_counter <= 0) {				\
+	    if (self_th->vm->gvl.acquired) {				\
+		gvl_release(self_th->vm, self_th);			\
+	    } else {							\
+		tend();							\
+		HTM_GVL_CHARGE_CYCLES_TO_AND_START(tx, between_tx);	\
+	    }								\
+	    htm_gvl_acquire_multi_threads(self_th, (cntaddr));		\
+	    rb_thread_set_current(th);					\
+	}								\
+    }									\
+} while (0)
+#endif
+
 #define RUBY_VM_CHECK_INTS_TH(th) do { \
     if (UNLIKELY((th)->interrupt_flag)) { \
 	rb_threadptr_execute_interrupts(th); \
diff -Naur ruby-1.9.3-p547.original/vm_exec.c ruby-1.9.3-p547.htm/vm_exec.c
--- ruby-1.9.3-p547.original/vm_exec.c	2011-05-31 11:08:58.000000000 +0900
+++ ruby-1.9.3-p547.htm/vm_exec.c	2014-09-12 06:37:35.905002000 +0900
@@ -6,6 +6,7 @@
   $Author: naruse $
 
   Copyright (C) 2004-2007 Koichi Sasada
+  Copyright (c) IBM Corp. 2014.
 
 **********************************************************************/
 
@@ -34,7 +35,11 @@
 #endif
 
 #if !OPT_CALL_THREADED_CODE
+#ifdef HTM_GVL
+VALUE
+#else
 static VALUE
+#endif
 vm_exec_core(rb_thread_t *th, VALUE initial)
 {
 
@@ -63,6 +68,12 @@
     register rb_control_frame_t *reg_cfp;
     VALUE *reg_pc;
 #endif
+#ifdef HTM_GVL
+    rb_thread_t *self_th = th ? th : GET_THREAD();
+    int thread_alone = rb_thread_alone_fast(self_th);
+    int use_gvl = self_th->vm->use_gvl;
+    int64_t local_schedule_counter;
+#endif
 
 #if USE_MACHINE_REGS
 
